package jalview.io;

import javax.swing.filechooser.FileView;
import javax.swing.*;
import java.io.*;
import java.util.*;

public class JalviewFileView extends FileView
{
  static Hashtable alignSuffix = new Hashtable();
  static{
    alignSuffix.put("fasta", "Fasta file");
    alignSuffix.put("fa", "Fasta file");
    alignSuffix.put("fastq", "Fasta file");
    alignSuffix.put("blc", "BLC file");
    alignSuffix.put("msf", "MSF file");
    alignSuffix.put("pfam", "PFAM file");
    alignSuffix.put("aln", "Clustal file");
    alignSuffix.put("pir", "PIR file");
  }
  public String getTypeDescription(File f)
  {
    String extension = getExtension(f);
    String type = null;

    if (extension != null)
    {
      if (alignSuffix.containsKey(extension))
      {
        type = alignSuffix.get(extension).toString();
      }
    }
    return type;
  }

  public Icon getIcon(File f)
  {
    String extension = getExtension(f);
    Icon icon = null;

    if (extension != null)
    {
      if (alignSuffix.containsKey(extension))
      {
        icon = createImageIcon("/images/file.png");
      }
    }
    return icon;
  }


  /*
   * Get the extension of a file.
   */
  public static String getExtension(File f) {
      String ext = null;
      String s = f.getName();
      int i = s.lastIndexOf('.');

      if (i > 0 &&  i < s.length() - 1) {
          ext = s.substring(i+1).toLowerCase();
      }
      return ext;
  }

  /** Returns an ImageIcon, or null if the path was invalid. */
  protected static ImageIcon createImageIcon(String path) {
      java.net.URL imgURL = JalviewFileView.class.getResource(path);
      if (imgURL != null) {
          return new ImageIcon(imgURL);
      } else {
          System.err.println("JalviewFileView.createImageIcon: Couldn't find file: " + path);
          return null;
      }
  }

}


